/***************************************************************************
                          qaddnewwindialog.cpp  -  description
                             -------------------
    begin                : Tue Aug 13 2002
    copyright            : (C) 2002 by Vadim A. Khohlov
    email                : xvadim@teko.kherson.ua
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>

#include <qlayout.h>
#include <qhbox.h>
#include <qlineedit.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qtextstream.h>
#include <qstring.h>

#include "qaddnewwindialog.h"

QAddNewWinDialog::QAddNewWinDialog(QWidget *parent, const char *name ):
QDialog(parent,name, true)
{
    QVBoxLayout *topLayout = new QVBoxLayout(this, 0);
    CHECK_PTR(topLayout);

	QHBox *hb = new QHBox(this);
	CHECK_PTR(hb);
	topLayout->addWidget(hb);
	QLabel *lb = new QLabel(tr("&WM_CLASS (class): "), hb);
	CHECK_PTR(lb);
	edClass = new QLineEdit(hb);
	CHECK_PTR(edClass);
	lb->setBuddy(edClass);

	hb = new QHBox(this);
	CHECK_PTR(hb);
	topLayout->addWidget(hb);
	lb = new QLabel(tr("W&M_CLASS (name): "), hb);
	CHECK_PTR(lb);
	edName = new QLineEdit(hb);
	CHECK_PTR(edName);
	lb->setBuddy(edName);
	
	hb = new QHBox(this);
	CHECK_PTR(hb);
	topLayout->addWidget(hb);
	lb = new QLabel(tr("WM_&ROLE: "), hb);
	CHECK_PTR(lb);
	edRole = new QLineEdit(hb);
	CHECK_PTR(edRole);
	lb->setBuddy(edRole);

	QPushButton *pb = new QPushButton(tr("Run xprop"), this);
	CHECK_PTR(pb);
	topLayout->addWidget(pb);
	connect(pb, SIGNAL(clicked()), SLOT(slotXprop()));


	hb = new QHBox(this);
	CHECK_PTR(hb);
	topLayout->addWidget(hb);
	pbOk = new QPushButton(tr("Ok"), hb);
	CHECK_PTR(pbOk);
	pbOk->setEnabled(false);
	connect(pbOk, SIGNAL(clicked()), SLOT(accept()));
	
	pb = new QPushButton(tr("Cancel"), hb);
	CHECK_PTR(pb);
	connect(pb, SIGNAL(clicked()), SLOT(reject()));

	edClass->setFocus();
	pbOk->setDefault(true);
	
	connect(edClass, SIGNAL(textChanged(const QString&)),
		             SLOT(slotTextChanged(const QString&)));
	connect(edName, SIGNAL(textChanged(const QString&)),
		             SLOT(slotTextChanged(const QString&)));
	connect(edRole, SIGNAL(textChanged(const QString&)),
		             SLOT(slotTextChanged(const QString&)));
} /* Constructor */

QAddNewWinDialog::~QAddNewWinDialog()
{
} /* QAddNewWinDialog::~QAddNewWinDialog() */

void QAddNewWinDialog::slotTextChanged(const QString&)
{
	pbOk->setEnabled(!edClass->text().isEmpty() || !edName->text().isEmpty() ||
			!edRole->text().isEmpty());
} /* void QAddNewWinDialog::slotTextChanged(const QString&) */

/**
 * Runs xprop for geting wm_class and wm_name.
 */
void QAddNewWinDialog::slotXprop()
{
	FILE *fptr;
	QString str;
	QString wm_name("WM_CLASS(STRING) = ");
	QString wm_class("\", \"");
	QString wm_role("WM_WINDOW_ROLE(STRING) = ");
	fptr = popen("xprop", "r");
	if(!fptr)
		return;
	
	QTextStream xpropStream(fptr, IO_ReadOnly);
	edName->clear();
	edClass->clear();
	edRole->clear();
	while((str = xpropStream.readLine()) != QString::null)
	{
		if(!str.find(wm_name))
		{
			str = str.remove(0, wm_name.length() + 1);
			edName->setText(str.remove(str.length() - 1, 1));
			str = str.remove(0, str.find(wm_class) + wm_class.length());
			edClass->setText(str);
			str = edName->text();
			edName->setText(str.remove(str.find(wm_class), str.length() - wm_class.length()));

		} /* 		if(!str.find(wm_name)) */
		if(!str.find(wm_role))
		{
			str = str.remove(0, wm_role.length() + 1);
			edRole->setText(str.remove(str.length() - 1, 1));
		} /* 		if(!str.find(wm_role)) */
	} /* 	while((str = xpropStream.readLine()) != QString::null) */
	pclose(fptr);
} /* void QAddNewWinDialog::slotXprop() */
