/***************************************************************************
                          qaddnewwindialog.h  -  description
                             -------------------
    begin                : Tue Aug 13 2002
    copyright            : (C) 2002 by Vadim A. Khohlov
    email                : xvadim@teko.kherson.ua
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QADDNEWWINDIALOG_H
#define QADDNEWWINDIALOG_H

#include <qwidget.h>
#include <qdialog.h>
#include <qstring.h>
#include <qlineedit.h>

class QPushButton;

/**
 * Dialog for adding new window.
 * @author Vadim A. Khohlov
 */

class QAddNewWinDialog : public QDialog  {
   Q_OBJECT
public: 
	QAddNewWinDialog(QWidget *parent=0, const char *name=0);
	~QAddNewWinDialog();
	QString wm_class() { return edClass->text(); }
	QString wm_name()  { return edName->text(); }
	QString wm_role()  { return edRole->text(); }
	void setWM_opt(const QString &wm_c, const QString &wm_n,
			const QString &wm_r)
	{
		edClass->setText(wm_c);
		edName->setText(wm_n);
		edRole->setText(wm_r);
	} /* 	void setWM_opt(const QString &wm_c, const QString &wm_n) */
private slots: // Private slots
    void slotTextChanged(const QString &dummy);
    /**
     * Runs xprop for geting wm_class and wm_name.
     */
    void slotXprop();
private:
	QLineEdit *edClass;
	QLineEdit *edName;
	QLineEdit *edRole;
	QPushButton *pbOk;
};

#endif
